@ECHO OFF

REM Set environment
  SETLOCAL
  SET Prompt=mf$G
  TITLE MetaFLAC: Directory-Wide Operations v2.1.0

GOTO BeginProc

REM Bug: Bypass not working

REM v2.1.1 2004-02-18 
REM Now checks that metaflac.exe is available.

REM v2.1.0 2003-12-29 
REM Added /S option to recurse directories
REM Renamed and changed format of command-line options
REM Removed A operation, now allow -P and -V combination

REM v2.0.2 2003-12-26 
REM Fixed bug in code when use default parameters ("N" option).

REM v2.0.1 2003-Dec-02 
REM Fixed bug that caused Full Help to be displayed when started with
REM  invalid command line parameters.
REM Changed code to print full directory name in report for V option, 
REM  instead of what the user typed in the FLAC files directory prompt. 

REM v2.0.0 2003-Dec-01 
REM Added B operation to send parameters directly to metaflac.exe
REM Added Y switch to provide an automated (silent) operating mode.
REM Added Tips and Examples to the help screen.
REM Added ability to specify filename mask, not just the file extension.

REM v1.0.0 2003-Nov-28 
REM Added functionality to Show Properties and Vorbis Comments of a directory of FLAC files.
REM Added Help if user runs batch file without correct parameters

REM v0.0.0 2003-Nov-27 
REM Original code to Add ReplayGain to a directory of FLAC files.

REM Check OS
  IF NOT %OS% == Windows_NT GOTO Err_NotWinNTx

REM List of Environment Variables used
    REM Common : mfOp, mfPath, mfFPath, mfFileMask, mfPromptUser, mfSubdirectories, mfNbArg
    REM R      : mfrCnt, mfrFiles
    REM B      : mfbParms, mfbOutFile
    REM V, P   : mfsOutFile, mfsTempVar

REM List of Labels used
    REM Common : Err_NotWinNTx, DisplayHelp, ExitProcedure, Cleanup, GenerateFileList
    REM R      : ReplayGain, rg2CreateBat, rgRenameFiles
    REM B      : Bypass
    REM V, P   : Show, sh2Add, sh2Properties

REM List of Files used
    REM Common : mfFFiles.txt
    REM R      : mfrRename.bat, mfrRevert.bat
    REM B      : mfb.txt
    REM V, P   : mfs.txt

:BeginProc

REM Check calling parameters
  IF x%1==x (GOTO DisplayHelp) ELSE (SET mfNbArg=1)
  IF x%2==x (GOTO Check1) ELSE (SET mfNbArg=2)
  IF x%3==x (GOTO Check2) ELSE (SET mfNbArg=3)
  IF x%4==x (GOTO Check3) ELSE (SET mfNbArg=4)
  GOTO Check%mfNbArg%

:Check4
  IF /I %4==/P (SET mfPromptUser=Y || GOTO Check3)
  IF /I %4==/S (SET mfSubdirectories=/S || GOTO Check3)
  IF /I %4==-B (SET mfOp=B || GOTO Check3)
  IF /I %4==-R (SET mfOp=R || GOTO Check3)
  IF /I %4==-P SET mfOp=P
  IF /I %4==-V SET mfOp=%mfOp%V

:Check3
  IF /I %3==/P (SET mfPromptUser=Y || GOTO Check2)
  IF /I %3==/S (SET mfSubdirectories=/S || GOTO Check2)
  IF /I %3==-B (SET mfOp=B || GOTO Check2)
  IF /I %3==-R (SET mfOp=R || GOTO Check2)
  IF /I %3==-P SET mfOp=P
  IF /I %3==-V SET mfOp=%mfOp%V

:Check2
  IF /I %2==/P (SET mfPromptUser=Y || GOTO Check1)
  IF /I %2==/S (SET mfSubdirectories=/S || GOTO Check1)
  IF /I %2==-B (SET mfOp=B || GOTO Check1)
  IF /I %2==-R (SET mfOp=R || GOTO Check1)
  IF /I %2==-P SET mfOp=P
  IF /I %2==-V SET mfOp=%mfOp%V

:Check1
  IF /I %1==/P (SET mfPromptUser=Y || GOTO Check)
  IF /I %1==/S (SET mfSubdirectories=/S || GOTO Check)
  IF /I %1==-B (SET mfOp=B || GOTO Check)
  IF /I %1==-R (SET mfOp=R || GOTO Check)
  IF /I %1==-P SET mfOp=P
  IF /I %1==-V SET mfOp=%mfOp%V

:Check
  IF x%mfOp%==x GOTO DisplayHelp

REM Get metaflac ^& files path, ^& file extension 
  REM Set Defaults
    SET mfPath=C:\Program Files\FLAC
    SET mfFPath=%CD%
    SET mfFileMask=*.flac

  REM Check whether to prompt user
    IF NOT x%mfPromptUser%==xY GOTO GenerateFileList
    
  REM Add path to metaflac to the environment
    ECHO.
    ECHO If metaflac.exe is not at %mfPath%,
    ECHO then enter the correct path below.
:lGetMetaflacPath
    SET /P mfPath=metaflac path: 
    IF NOT EXIST "%mfPath%\metaflac.exe" (ECHO Incorrect Path) && (GOTO lGetMetaflacPath)

  REM Change to drive ^& directory with FLAC files
    ECHO.
    ECHO If the current directory (%mfFPath%)
    ECHO is not the path with the FLAC files,
    ECHO then enter the correct path below.
    SET /P mfFPath=FLAC directory: 

  REM Get Filename Mask
    ECHO.
    ECHO If "*.flac" is not the correct filename mask,
    ECHO then enter the correct mask below.
    SET /P mfFileMask=Filename Mask: 

:GenerateFileList
    SET PATH=%mfPath%;%PATH%
    PUSHD %mfFPath%
    DIR /B /O:N %mfSubdirectories% "%mfFileMask%" > mfFFiles.txt

REM Check Operation
  IF %mfOp%==B GOTO Bypass
  IF %mfOp%==R GOTO ReplayGain
  GOTO Show


:Bypass
  REM Get Parameters
    SET mfbParms=
    IF x%3==x (GOTO DisplayHelp) ELSE (SET mfbParms=%3)
    IF NOT x%4==x SET mfbParms=%mfbParms% %4    
    IF NOT x%5==x SET mfbParms=%mfbParms% %5   
    IF NOT x%6==x SET mfbParms=%mfbParms% %6
    IF NOT x%7==x SET mfbParms=%mfbParms% %7
    IF NOT x%8==x SET mfbParms=%mfbParms% %8
    IF NOT x%9==x SET mfbParms=%mfbParms% %9

  SET mfbOutFile="%TEMP%\Flac.txt"

  ECHO.
  ECHO Performing operation on:

  ECHO ================================================================================ >  %mfbOutFile%
  ECHO ================================================================================ >> %mfbOutFile%
  ECHO Directory: %CD%>> %mfbOutFile%
  ECHO ================================================================================ >> %mfbOutFile%
  
  FOR /F "tokens=*" %%F IN (mfFFiles.txt) DO CALL :bpSend "%%F"

  Notepad.exe %mfbOutFile%

  DEL /Q %mfbOutFile%  > nul

  GOTO Cleanup
  
:bpSend
  ECHO   %1
  ECHO ================================================================================ >> %mfbOutFile%
  ECHO File: %1>> %mfbOutFile%
  ECHO -------------------------------------------------------------------------------- >> %mfbOutFile%

  metaflac.exe %mfbParms% %1 >> %mfbOutFile%
  GOTO ExitProcedure


:ReplayGain
  REM Set Variables
    SET mfrCnt=0
    SET mfrFiles=

  REM Cleanup
    DEL /Q mfrRename.bat 2> nul
    DEL /Q mfrRevert.bat 2> nul

  REM Create Rename ^& Revert bat
    FOR /F "tokens=*" %%F IN (mfFFiles.txt) DO CALL :rg2CreateBat "%%F"
    GOTO rgRenameFiles

:rg2CreateBat
    SET /A mfrCnt = mfrCnt + 1
    SET mfrFiles=%mfrFiles% %mfrCnt%
    ECHO REN %1 %mfrCnt% >> mfrRename.bat
    ECHO REN %mfrCnt% %1 >> mfrRevert.bat
    GOTO ExitProcedure

:rgRenameFiles
    CALL mfrRename.bat > nul

  ECHO Updating Track ^& Album ReplayGain values
  ECHO This may take a long time, so go have a coffee 8-)
    metaflac.exe --preserve-modtime --no-utf8-convert --add-replay-gain %mfrFiles%
    metaflac.exe --sort-padding %mfrFiles%

  REM Revert file names
    CALL mfrRevert.bat > nul

  REM Cleanup
    DEL /Q mfrRename.bat > nul
    DEL /Q mfrRevert.bat > nul

  REM Success!
    ECHO.
    ECHO %mfrCnt% files were tagged.
    ECHO.
    ECHO Press any key to exit.
    PAUSE > nul
  
  GOTO Cleanup


:Show
  SET mfsOutFile="%TEMP%\Flac.txt"
  SET mfsTempVar=
  
  ECHO.
  ECHO Reading

  ECHO ================================================================================ >  %mfsOutFile%
  ECHO ================================================================================ >> %mfsOutFile%
  ECHO Directory: %CD%>> %mfsOutFile%
  ECHO ================================================================================ >> %mfsOutFile%

  FOR /F "tokens=*" %%F IN (mfFFiles.txt) DO CALL :sh2Add "%%F"

  Notepad.exe %mfsOutFile%

  DEL /Q mfs.txt       > nul
  DEL /Q %mfsOutFile%  > nul

  GOTO Cleanup

:sh2Add
    ECHO   %1
    ECHO ================================================================================ >> %mfsOutFile%
    ECHO File: %1>> %mfsOutFile%
    ECHO -------------------------------------------------------------------------------- >> %mfsOutFile%

    IF %mfOp%==P GOTO sh2Properties

    metaflac.exe --export-vc-to=mfs.txt %1
    COPY /A /Y %mfsOutFile%+mfs.txt %mfsOutFile% > nul

    IF %mfOp%==V GOTO ExitProcedure

:sh2Properties
    metaflac.exe --show-md5sum %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO md5sum=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-min-blocksize %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO min-blocksize=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-max-blocksize %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO max-blocksize=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-min-framesize %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO min-framesize=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-max-framesize %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO max-framesize=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-sample-rate %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO sample-rate=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-channels %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO channels=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-bps %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO bps=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-total-samples %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO total-samples=%mfsTempVar% >> %mfsOutFile%

    metaflac.exe --show-vc-vendor %1 > mfs.txt
    FOR /F %%F IN (mfs.txt) DO SET mfsTempVar=%%F
    ECHO vc-vendor=%mfsTempVar% >> %mfsOutFile%

    GOTO ExitProcedure


:DisplayHelp
  ECHO.
  ECHO ********** Front-end for metaflac.exe v1.1.0 **********
  ECHO Operations are performed on **ALL** specified FLAC files
  ECHO  in the given directory.
  ECHO.
  ECHO Usage:
  ECHO   mf[.bat] [/H^|[/P /S]] [-B^|-R^|[-P -V]]
  ECHO   mf[.bat] [switches] [operations] [parameters]
  ECHO.
  ECHO Switches:
  ECHO   /P, Prompt user for the path to metaflac.exe and the FLAC files,
  ECHO         and the FLAC filename mask.
  ECHO         The defaults are "C:\Program Files\FLAC", current directory, and "*.flac".
  ECHO   /H, Displays this help message
  ECHO   /S, Recurse subdirectories (ignored for -R operation)
  ECHO.
  ECHO Operations:
  ECHO   -A, Display Vorbis Comments ^& FLAC Properties
  ECHO   -B, Bypass, (upto 7) parameters are sent directly to metaflac.exe
  ECHO       Each parameter must be enclosed in double quotes (") and
  ECHO       must be separated by a space ( ).
  ECHO   -P, Shows the FLAC Properties
  ECHO   -R, Add Replay Gain tags
  ECHO   -V, Shows the Vorbis Comments
  ECHO.
  ECHO Notes:
  ECHO 1. All operations (and parameters) will be performed on all
  ECHO     applicable files in the given directory.
  ECHO 2. The following operations CANNOT be combined: -B, -R.
  ECHO     Only the first operation will be executed.
  ECHO.
  ECHO Tips:
  ECHO 1. When prompted for the FLAC directory, you can use the single dot (.)
  ECHO     to denote the current directory.
  ECHO     E.g., If mf.bat is in D:\My\Music and the files are in D:\My\Music\Meat Loaf
  ECHO     then at the prompt type ".\Meat Loaf" (without the quotes).
  ECHO 2. When prompted for the filename mask, you can enter something like:
  ECHO     "Bat out of Hell*.flac" (without the quotes).
  ECHO.
  ECHO Examples:
  ECHO 1. mf /S -P -V
  ECHO    Displays FLAC Properties ^& Vorbis Comments for all *.flac files
  ECHO     in the current directory and all subdirectories.
  ECHO 2. mf /P -R
  ECHO    Adds ReplayGain to all user specified files in a user specified directory
  ECHO     (user will be prompted for path and filename mask),
  ECHO     treating all the files as a single album.
  ECHO.
  GOTO ExitProcedure

:Err_NotWinNTx
  ECHO.
  ECHO ****************************************************
  ECHO ****************************************************
  ECHO **                                                **
  ECHO **  You must be running WinNT4, Win2000 or WinXP  **
  ECHO **  to use this tool.                             **
  ECHO **                                                **
  ECHO ****************************************************
  ECHO ****************************************************
  GOTO Completed


:Cleanup
  DEL /Q mfFFiles.txt > nul
  POPD
  ENDLOCAL

:ExitProcedure
